/**
 * @author Administrator
 * 
 * TODO To change the template for this generated type comment go to Window - Preferences - Java -
 * Code Style - Code Templates
 */

package com.ibm.jps.umltoxml.transformation.rules;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.core.resources.IProject;
import org.eclipse.uml2.Class;
import org.eclipse.uml2.Element;
import org.eclipse.uml2.Model;
import org.eclipse.uml2.NamedElement;
import org.eclipse.uml2.Package;
import org.eclipse.uml2.UML2Package;

import com.ibm.jps.umltoxml.util.ResourceUtility;
import com.ibm.xtools.transform.core.AbstractRule;
import com.ibm.xtools.transform.core.ITransformContext;
import com.ibm.xtools.transform.uml2.IsElementKindCondition;

/*
 * (non-Javadoc)
 * 
 * @see com.ibm.xtools.transform.core.AbstractRule
 */
public class ExtractRule extends AbstractRule {
    public final static String ID = "com.ibm.jps.umltoxml.regleModele"; //$NON-NLS-1$
    public final static String NAME = "com.ibm.jps.umltoxml.regleModele.name"; //$NON-NLS-1$

    public List targetClasses = null;

    /**
     * Default constructor to create a rule.
     */
    public ExtractRule() {
        super();
        setAcceptCondition(new IsElementKindCondition(UML2Package.eINSTANCE.getModel()));
    }

    /**
     * constructor
     * 
     * @param id
     * @param name
     */
    public ExtractRule(String id, String name) {
        super(id, name);
        setAcceptCondition(new IsElementKindCondition(UML2Package.eINSTANCE.getModel()));
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.xtools.transform.core.AbstractRule#createTarget(com.ibm.xtools.transform.core.ITransformContext)
     */
    public Object createTarget(ITransformContext context) {
        System.out.println("--- Model extraction rule");
        NamedElement element = (NamedElement) context.getSource();
        Model model = (Model) element;
        Object targetContainer = context.getTargetContainer();
        IProject project = (targetContainer instanceof IProject) ? (IProject) targetContainer : ResourceUtility
                .getProject(element);
        targetClasses = new ArrayList();
        processPackage(model);
        context.setPropertyValue("TargetClasses", targetClasses);
        return null;
    }

    private void processPackage(Package pkg) {
        processOnePackage(pkg);
        for (Iterator i = pkg.getNestedPackages().iterator(); i.hasNext();) {
            processPackage((Package) i.next());
        }
    }

    /**
     * @param pkg
     */
    private void processOnePackage(Package pkg) {
        for (Iterator i = pkg.getOwnedMembers().iterator(); i.hasNext();) {
            Element elt = (Element) i.next();
            if (elt instanceof Class) {
                processClass((Class) elt);
            }
        }
    }

    /**
     * @param class1
     */

    private void processClass(Class cl) {
        System.out.println("    Adding class " + cl.getName());
        // TODO Add any criteria to limit targetClasses to whatever classes you want 
        targetClasses.add(cl);
    }

}
