/*
 * Created on Jul 11, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.jps.umltoxml.transformation.rules;

import org.eclipse.core.resources.IProject;
import org.eclipse.uml2.NamedElement;
import org.eclipse.uml2.UML2Package;

import com.ibm.jps.umltoxml.util.ResourceUtility;
import com.ibm.xtools.transform.core.AbstractRule;
import com.ibm.xtools.transform.core.ITransformContext;
import com.ibm.xtools.transform.uml2.IsElementKindCondition;


/**
 * @author Administrator
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
public class InitRule extends AbstractRule {
    public final static String ID = "com.ibm.jps.umltoxml.regleInitialisation"; //$NON-NLS-1$
    public final static String NAME = "com.ibm.jps.umltoxml.regleInitialisation.name"; //$NON-NLS-1$

    /**
     * Default constructor. Initializes the id and the name to the default
     * values. Also initializes the rule to accept a UML class as source.
     */
    public InitRule() {
        super(ID, NAME);
		setAcceptCondition(new IsElementKindCondition(UML2Package.eINSTANCE.getClass_()));
   }

    /**
     * Constructor. Initializes the id and the name of the rule and initializes
     * the rule to accept a UML class as source.
     * 
     * @param id
     *            Unique id of the rule
     * @param name
     *            Readable name of the rule.
     */
    public InitRule(String id, String name) {
        super(id, name);
		setAcceptCondition(new IsElementKindCondition(UML2Package.eINSTANCE.getClass_()));
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.xtools.transform.core.AbstractRule#createTarget(com.ibm.xtools.transform.core.ITransformContext)
     */
    protected Object createTarget(ITransformContext context) throws Exception {
        System.out.println("--- Initialization rule");
        NamedElement element = (NamedElement) context.getSource();
        Object targetContainer = context.getTargetContainer();

        // If a target container is not chosen or the selected target container
        // is not a IProject, choose the project containing the source model
        // element to be the target container.
        IProject project = (targetContainer instanceof IProject) ? (IProject) targetContainer
                : ResourceUtility.getProject(element);

        context.setPropertyValue("targetProject", project); //$NON-NLS-1$
        return null;
    }

}
