/**
 * @author Administrator
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */

package com.ibm.jps.umltoxml.transformationProvider;

import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.uml2.UML2Package;

import com.ibm.xtools.transform.core.ITransformContext;
import com.ibm.xtools.transform.core.ITransformationDescriptor;
import com.ibm.xtools.transform.core.RootTransform;

/*
 * (non-Javadoc)
 * 
 * @see com.ibm.xtools.transform.core.RootTransform
 */
public class UMLToXMLRootTransformation extends RootTransform {

    /**
     * Constructor.
     * 
     * @param descriptor
     *            A transformation descriptor.
     */
    public UMLToXMLRootTransformation(ITransformationDescriptor descriptor) {
        super(descriptor);

        // Initialize root transform with main UML transform.
        // The false argument indicates the main transform will only
        // accept individual source objects (and not the list of selected
        // objects).
        UMLToXMLTransformation mainTransform = new UMLToXMLTransformation(descriptor.getId());
        mainTransform.setName(descriptor.getName());

        // Define the rules to be executed before and after the main UML
        // transform.
        setupInitialize();
        initialize(mainTransform, false);
        setupFinalize();
    }

    /**
     * Add rules in this method that will be called once before the main UML
     * transform is executed.
     */
    private void setupInitialize() {
    }

    /**
     * Add rules in this method that will be called once after the main UML
     * transform has been executed.
     */
    private void setupFinalize() {
    }

    /**
     * Determines if any member in the list of source objects specified in the
     * context is acceptable. This transformation accepts a model element of
     * type <code>class</code>.
     * 
     * This method iterates over the list supplied as the source and returns
     * true if any of the members is a UML2 class.
     * 
     * @param context
     *            A context that contains the source and target info.
     * @return boolean - true if the context is acceptable
     */
    
    public boolean canAccept(ITransformContext context) {
        boolean accepted = false;
        UML2Package uml = UML2Package.eINSTANCE;
        if (context.getSource() instanceof List) {
            Iterator iter = ((List) context.getSource()).iterator();
            while (!accepted && iter.hasNext()) {
                Object element = iter.next();
                if (element instanceof EObject) {
                    EClass kind = ((EObject) element).eClass();
                    accepted = (kind == uml.getModel());
                }
            }
        }
        return accepted;
    }
}
