/*
 * Created on Jul 11, 2006
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.jps.umltoxml.util;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.emf.common.util.EList;
import org.eclipse.uml2.Association;
import org.eclipse.uml2.Class;
import org.eclipse.uml2.Element;
import org.eclipse.uml2.Package;
import org.eclipse.uml2.Property;
import org.eclipse.uml2.Type;

/**
 * @author Administrator
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class ModelUtility {
    public static List findAssocClasses(Class fromClass) {
        List assocs = new ArrayList();
        Package pkg = fromClass.getModel();
        if (pkg != null) {
            addAssociations(assocs, pkg, fromClass);
        }
        return assocs;
    }

    private static void addAssociations(List toList, Package inPkg,
            Class fromClass) {
        for (Iterator i = inPkg.getOwnedElements().iterator(); i.hasNext();) {
            Element ownedElt = (Element) i.next();
            if (ownedElt instanceof Association) {
                Association assoc = (Association) ownedElt;
                EList members = assoc.getMemberEnds();
                if (members.size() >= 2) {
                    Property prop1 = (Property) members.get(0);
                    Property prop2 = (Property) members.get(1);
                    Type type1 = prop1.getType();
                    Type type2 = prop2.getType();
                    if (type1 instanceof Class && type2 instanceof Class) {
                        Class cl1 = (Class) type1;
                        Class cl2 = (Class) type2;
                        if (cl1.equals(fromClass) || cl2.equals(fromClass)) {
                            Class targetClass = (cl1.equals(fromClass)) ? cl2
                                    : cl1;
                            toList.add(targetClass);
                        }
                    }
                }
            }
        }
        // Search the nested packages
        for (Iterator i = inPkg.getNestedPackages().iterator(); i.hasNext();) {
            addAssociations(toList, (Package) i.next(), fromClass);
        }
    }

    public static String convertToJavaPath(String input) {
        return getPath(convertToFullJavaName(input));
    }
 
    /**
     * Given an input string of the type "com.company.project.AClass", getPath will return
     * "com.company.project" (or an empty string if the input string is "AClass").
     * 
     * @param name
     * @return
     */
    public static String getPath(String name) {
        int pos = name.lastIndexOf(".");
        if (pos > 0)
            return name.substring(0, pos);
        else
            return "";
    }
    
    public static String convertToFullJavaName(String input) {
        return replaceAllSubstrings(getNameWithoutModel(input), "::", ".");
    }
    
    public static String replaceAllSubstrings(String inputString, String fromExp, String toExp) {
        if (fromExp.equals(inputString)) return toExp;
        int pos;
        int prev = 0;
        String res = "";
        do {
            pos = inputString.indexOf(fromExp, prev);
            if (pos == -1) {
                res = res + inputString.substring(prev);
            } else {
                if (pos > prev) res = res + inputString.substring(prev, pos);
                res = res + toExp;
            }
            prev = pos + fromExp.length();
        } while (pos >= 0);
        return res;
    }

    public static String getNameWithoutModel(String name) {
        int pos = name.indexOf("::");
        if (pos > 0)
            return name.substring(name.indexOf("::") + 2);
        else
            return name;
    }
    
    public static String convertToSimpleJavaName(String input) {
        return getSimpleName(convertToFullJavaName(input));
    }
    
    /**
     * Given an input string of the type "com.company.project.AClass", getSimpleName will return
     * "AClass" (or the string itself if the input string is "AClass").
     * 
     * @param name
     * @return
     */
    public static String getSimpleName(String name) {
        int pos = name.lastIndexOf(".");
        if (pos > 0)
            return name.substring(pos + 1);
        else
            return name;
    }
    
    /**
     * @param name
     * @return
     */
    public static String firstCharToUpperCase(String name) {
        return name.substring(0, 1).toUpperCase() + name.substring(1);
    }

    /**
     * @param name
     * @return
     */
    public static String firstCharToLowerCase(String name) {
        return name.substring(0, 1).toLowerCase() + name.substring(1);
    }
}
